package vip.xiaonuo.erp.controller;


import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;
import vip.xiaonuo.common.pojo.CommonResult;
import vip.xiaonuo.erp.entity.ErpBdMaterial;
import vip.xiaonuo.erp.entity.ErpBdMaterialGroup;
import vip.xiaonuo.erp.entity.ErpBdRawMaterial;
import vip.xiaonuo.erp.mapper.ErpBdMaterialGroupMapper;
import vip.xiaonuo.erp.mapper.ErpBdRawMaterialMapper;
import vip.xiaonuo.erp.param.ErpBdMaterialEdParam;
import vip.xiaonuo.erp.param.ErpBdMaterialParentParam;
import vip.xiaonuo.erp.service.IErpBdMaterialGroupService;
import vip.xiaonuo.erp.service.IErpBdRawMaterialService;
import vip.xiaonuo.write.entity.WriteWarning;

import java.util.List;

/**
 * <p>
 * 原材料列表 前端控制器
 * </p>
 *
 * @author author
 * @since 2025-03-17
 */
@Api(tags = "物料查询控制器")
@RestController
@RequestMapping("/erp-bd-raw-material")
public class ErpBdRawMaterialController {
    @Autowired
    private IErpBdRawMaterialService erpBdRawMaterialService;

    @PostMapping("/getAllChanPin")
    public CommonResult<List<ErpBdRawMaterial>> edit(@RequestBody ErpBdMaterialParentParam erpBdMaterial) {
        return CommonResult.data( erpBdRawMaterialService.list(new QueryWrapper<ErpBdRawMaterial>()
                .eq("org_id","1856160583875837954").likeRight("erp_fnumber","01")));
    }


    @PostMapping("/pageChanPinGuanZhu")
    @ApiOperation("物料分页")
    public CommonResult<Page<ErpBdRawMaterial>> pageChanPinGuanZhu(@RequestBody ErpBdMaterialParentParam erpBdMaterial) {
        Integer pageNum = erpBdMaterial.getPageNum();
        Integer pageSize = erpBdMaterial.getPageSize();
        String materialName = erpBdMaterial.getMaterialName();
        if(ObjectUtil.isEmpty(pageNum)){
            pageNum =1;
        }
        if(ObjectUtil.isEmpty(pageSize)){
            pageSize =10;
        }

        Page<ErpBdRawMaterial> page = new Page<>(pageNum,pageSize);
        QueryWrapper<ErpBdRawMaterial> erpBdRawMaterialQueryWrapper = new QueryWrapper<ErpBdRawMaterial>()
                .eq(StringUtils.isNotBlank(erpBdMaterial.getOrgId()),"org_id",erpBdMaterial.getOrgId() ).likeRight("erp_fnumber", "01")
                .eq(ObjectUtil.isNotEmpty(erpBdMaterial.getIsFollow()),"is_follow",erpBdMaterial.getIsFollow())
                .like(StringUtils.isNotBlank(materialName),"fname",materialName).orderByDesc("is_follow");
        return CommonResult.data( erpBdRawMaterialService.page(page,erpBdRawMaterialQueryWrapper));
    }

    @PostMapping("/listChanPinGuanZhu")
    @ApiOperation("关注列表")
    public CommonResult<List<ErpBdRawMaterial>> listChanPinGuanZhu(@RequestBody ErpBdMaterialParentParam erpBdMaterial) {
        return CommonResult.data( erpBdRawMaterialService.list(new QueryWrapper<ErpBdRawMaterial>()
                .eq(StringUtils.isNotBlank(erpBdMaterial.getOrgId()),"org_id",erpBdMaterial.getOrgId() )
                .eq("is_follow",1)));
    }

    @PostMapping("/updateChanPinGuanZhu")
    @ApiOperation("物料修改")
    public CommonResult<String> listChanPinGuanZhu(@RequestBody ErpBdMaterialEdParam erpBdMaterial) {
        ErpBdRawMaterial erpBdMaterial1 = new ErpBdRawMaterial();
        erpBdMaterial1.setId(erpBdMaterial.getId());
        erpBdMaterial1.setIsFollow(erpBdMaterial.getIsFollow());
        erpBdRawMaterialService.updateById(erpBdMaterial1);

        return CommonResult.ok();
    }

}
