package vip.xiaonuo.erp.service.impl;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.ParameterizedTypeReference;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;
//import vip.xiaonuo.common.annotation.Test;
import vip.xiaonuo.erp.entity.ErpBdOrg;
import vip.xiaonuo.erp.entity.caigou.*;
import vip.xiaonuo.erp.entity.kucun.YangMaoZhiGongYingShang;
import vip.xiaonuo.erp.mapper.ErpBdOrgMapper;
import vip.xiaonuo.erp.service.IErpCaiGouService;
import vip.xiaonuo.erp.service.IErpShengChanService;
import vip.xiaonuo.purchase.entity.PurchaseContract;
import vip.xiaonuo.purchase.entity.PurchaseOrder;
import vip.xiaonuo.purchase.entity.PurchasePay;
import vip.xiaonuo.purchase.entity.PurchasePrice;
import vip.xiaonuo.purchase.mapper.PurchaseContractMapper;
import vip.xiaonuo.purchase.mapper.PurchaseOrderMapper;
import vip.xiaonuo.purchase.mapper.PurchasePayMapper;
import vip.xiaonuo.purchase.mapper.PurchasePriceMapper;

import java.util.Date;
import java.util.List;


@Service
public class ErpCaiGouServiceImpl implements IErpCaiGouService {
    @Autowired
    private RestTemplate restTemplate;

    //合同
    @Autowired
    private PurchaseContractMapper contractMapper;

    //订单
    @Autowired
    private PurchaseOrderMapper orderMapper;

    //付款
    @Autowired
    private PurchasePayMapper payMapper;

    //单价
    @Autowired
    private PurchasePriceMapper priceMapper;

    @Autowired
    private ErpBdOrgMapper erpBdOrgMapper;


     @Override
    public void getCaiGouDingDanShuLiangJinE(Date date) {

        String url = "http://127.0.0.1:9200/erp-caiGou/getCaiGouDingDanShuLiangJinE?date="+date;

        ResponseEntity<List<CaiGouDingDanShuLiangJinE>> response = restTemplate.exchange(
                url,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<CaiGouDingDanShuLiangJinE>>() {}
        );
        List<CaiGouDingDanShuLiangJinE> forObjects = response.getBody();
        for (CaiGouDingDanShuLiangJinE forObject : forObjects) {

            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFPURCHASEORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            PurchasePrice purchasePrice = new PurchasePrice();
            purchasePrice.setCreateTime(forObject.getFDATE());
            purchasePrice.setMaterial(forObject.getFname());
            purchasePrice.setOrgId(forgid.getOrgId());
            purchasePrice.setPrice(String.format("%.2f",forObject.getDanJia()));
            priceMapper.insert(purchasePrice);

            PurchaseOrder purchaseOrder =new PurchaseOrder();
            purchaseOrder.setCreateTime(forObject.getCreateDate());
            purchaseOrder.setPurchaseMoney(String.format("%.2f",forObject.getFALLAMOUNT()));
            purchaseOrder.setMaterial(forObject.getFname());
            purchaseOrder.setOrgId(forgid.getOrgId());
//                purchaseOrder.setMaterialAcceptNumber(String.format("%.2f",forObject.getFQTY()));
//                purchaseOrder.setMaterialAcceptPrice(String.format("%.2f",forObject.getFALLAMOUNT()));
            purchaseOrder.setSupplier(forObject.getGys());
            purchaseOrder.setFnumber(forObject.getFnumber());
            purchaseOrder.setOrderNumber(forObject.getFBILLNO());
            purchaseOrder.setCaiGou(forObject.getFQTY());
            purchaseOrder.setOrderType(getOrderType(forObject.getDingDanType()));
            orderMapper.insert(purchaseOrder);

        }
    }

    private Integer getOrderType(String dingDanType) {
        switch (dingDanType){
            //0原辅料包材采购合同 1五金材料采购合同 2设备采购合同 3工程服务采购合同 4其他服务类采购合同 5办公用品采购合同
            case "原辅料包材采购订单":
                return 0;
            case "五金材料采购订单":
                return 1;
            case "设备采购订单":
                return 2;
            case "工程服务采购订单":
                return 3;
            case "其他服务类采购订单":
                return 4;
            case "办公用品采购订单":
                return 5;
        }
        return 6;
    }
    private Integer getHeTongType(String dingDanType) {
        switch (dingDanType){
            //0原辅料包材采购合同 1五金材料采购合同 2设备采购合同 3工程服务采购合同 4其他服务类采购合同 5办公用品采购合同
            case "原辅料包材采购合同":
                return 0;
            case "五金材料采购合同":
                return 1;
            case "设备采购合同":
                return 2;
            case "工程服务采购合同":
                return 3;
            case "其他服务类采购合同":
                return 4;
            case "办公用品采购合同":
                return 5;
        }
        return 6;
    }

     @Override
    public void  getCaiGouRuku(Date date){
        ResponseEntity<List<CaiGouRuKu>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-caiGou/getCaiGouRuku?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<CaiGouRuKu>>() {}
        );
        List<CaiGouRuKu> forObjects = response.getBody();
        for (CaiGouRuKu forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFSTOCKORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;

            PurchaseOrder purchaseOrder = new PurchaseOrder();
            purchaseOrder.setEnterNumber(String.format("%.2f",forObject.getFQTY()));
            purchaseOrder.setEnterPrice(String.format("%.2f",forObject.getFBILLAMOUNTLC()));
            purchaseOrder.setRemarkRk(forObject.getPoorderNo());
            purchaseOrder.setMaterial(forObject.getFNAME());
            purchaseOrder.setFnumber(forObject.getFNUMBER());
            purchaseOrder.setRkNo(forObject.getFBILLNO());
            purchaseOrder.setOrgId(forgid.getOrgId());
            purchaseOrder.setCreateTime(forObject.getFDATE());
            orderMapper.insert(purchaseOrder);

        }

    }

     @Override
    public void  getCaiGouFaPiao(Date date ){
        ResponseEntity<List<FaPiaoJinE>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-caiGou/getCaiGouFaPiao?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<FaPiaoJinE>>() {}
        );
        List<FaPiaoJinE> forObjects = response.getBody();

        for (FaPiaoJinE forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFPURCHASEORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            if (forObject.getFALLAMOUNT() ==null){
                continue;
            }
            PurchaseOrder purchaseOrder =new PurchaseOrder();
            purchaseOrder.setCreateTime(forObject.getFDATE());
            purchaseOrder.setInvoicePrice(String.format("%.2f",forObject.getFALLAMOUNT()));
            purchaseOrder.setOrgId(forgid.getOrgId());

            orderMapper.insert(purchaseOrder);

        }

    }

   @Override
    public void  getLeiJiRuKu(Date date){
        ResponseEntity<List<LeiJiRuKu>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-caiGou/getLeiJiRuKu?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<LeiJiRuKu>>() {}
        );
        List<LeiJiRuKu> forObjects = response.getBody();

        for (LeiJiRuKu forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFDEMANDORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            List<PurchaseOrder> purchaseOrders = orderMapper.selectList(new QueryWrapper<PurchaseOrder>().eq("org_id", forgid.getOrgId())
                    .between("create_time",DateUtil.beginOfDay(forObject.getFDATE()),DateUtil.endOfDay(forObject.getFDATE())));
            if (ObjectUtil.isEmpty(purchaseOrders)){
                PurchaseOrder purchaseOrder =new PurchaseOrder();
                purchaseOrder.setCreateTime(forObject.getFDATE());
                purchaseOrder.setEnterNumber(String.format("%.2f",forObject.getFREALQTY()));
                purchaseOrder.setOrgId(forgid.getOrgId());
                orderMapper.insert(purchaseOrder);
            }else {
                PurchaseOrder purchaseOrder = purchaseOrders.get(0);
                purchaseOrder.setEnterNumber(String.format("%.2f",forObject.getFREALQTY()));
                orderMapper.updateById(purchaseOrder);
            }
        }
    }
    //-- 1
     @Override
    public void  getShouLiaoJinE(Date date){
        ResponseEntity<List<ShouLiaoJinE>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-caiGou/getShouLiaoJinE?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<ShouLiaoJinE>>() {}
        );
        List<ShouLiaoJinE> forObjects = response.getBody();

        for (ShouLiaoJinE forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFSTOCKORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            PurchaseOrder purchaseOrder = new PurchaseOrder();
            purchaseOrder.setMaterialAcceptNumber(String.format("%.2f",forObject.getFINSTOCKQTY()));
            purchaseOrder.setMaterialAcceptPrice(String.format("%.2f",forObject.getFBillAllAMONUTLC()));
            purchaseOrder.setRemarkRk(forObject.getFOrderBillNo());
            purchaseOrder.setMaterial(forObject.getFNAME());
            purchaseOrder.setFnumber(forObject.getFNUMBER());
            purchaseOrder.setHtNo(forObject.getFBILLNO());
            purchaseOrder.setCreateTime(forObject.getFDATE());
            purchaseOrder.setOrgId(forgid.getOrgId());
//            purchaseOrder.setHtNo(forObject.getFBILLNO());
            orderMapper.insert(purchaseOrder);

        }
    }

     @Override
    public void  getJiaoHuoShuLiang(Date date){
        ResponseEntity<List<JiaoHuoShuliang>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-caiGou/getJiaoHuoShuLiang?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<JiaoHuoShuliang>>() {}
        );
        List<JiaoHuoShuliang> forObjects = response.getBody();


        for (JiaoHuoShuliang forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFSTOCKORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            List<PurchaseOrder> purchaseOrders = orderMapper.selectList(new QueryWrapper<PurchaseOrder>().eq("org_id", forgid.getOrgId())
                    .between("create_time",DateUtil.beginOfDay(forObject.getFDATE()),DateUtil.endOfDay(forObject.getFDATE())));
            PurchaseOrder purchaseOrder =new PurchaseOrder();
            if (ObjectUtil.isEmpty(purchaseOrders)){

                purchaseOrder.setCreateTime(forObject.getFDATE());
                purchaseOrder.setJiaoHuo(forObject.getFACTRECEIVEQTY());
                purchaseOrder.setOrgId(forgid.getOrgId());
                orderMapper.insert(purchaseOrder);
            }else {
                purchaseOrder = purchaseOrders.get(0);
                purchaseOrder.setJiaoHuo(forObject.getFACTRECEIVEQTY());
                orderMapper.updateById(purchaseOrder);
            }
            if (purchaseOrder.getJiaoHuo()!=null && purchaseOrder.getCaiGou()!=null){
                purchaseOrder.setRank(String.format("%.2f",purchaseOrder.getJiaoHuo() / purchaseOrder.getCaiGou()));
            }
            orderMapper.updateById(purchaseOrder);
        }
    }


     @Override
    public void  getCaiGouShuLiang(Date date){
        ResponseEntity<List<CaiGouShuLiang>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-caiGou/getCaiGouShuLiang?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<CaiGouShuLiang>>() {}
        );
        List<CaiGouShuLiang> forObjects = response.getBody();

        for (CaiGouShuLiang forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFPURCHASEORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            List<PurchaseOrder> purchaseOrders = orderMapper.selectList(new QueryWrapper<PurchaseOrder>().eq("org_id", forgid.getOrgId())
                    .between("create_time",DateUtil.beginOfDay(forObject.getFDATE()),DateUtil.endOfDay(forObject.getFDATE())));
            PurchaseOrder purchaseOrder =  new PurchaseOrder();;
            if (ObjectUtil.isEmpty(purchaseOrders)){
                purchaseOrder.setCreateTime(forObject.getFDATE());
                purchaseOrder.setCaiGou(forObject.getFQTY());
                purchaseOrder.setOrgId(forgid.getOrgId());
                orderMapper.insert(purchaseOrder);
            }else {
                purchaseOrder = purchaseOrders.get(0);
                purchaseOrder.setCaiGou(forObject.getFQTY());
            }
            if (purchaseOrder.getJiaoHuo()!=null && purchaseOrder.getCaiGou()!=null){
                purchaseOrder.setRank(String.format("%.2f",purchaseOrder.getJiaoHuo() / purchaseOrder.getCaiGou()));
            }
            orderMapper.updateById(purchaseOrder);
        }
    }

    //重新写了 TODO
     @Override
    public void  getYingFuZhangKuang(Date date){
        ResponseEntity<List<YingFuZhangKuan>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-caiGou/getYingFuZhangKuang?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<YingFuZhangKuan>>() {}
        );
        List<YingFuZhangKuan> forObjects = response.getBody();


        for (YingFuZhangKuan forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFPURCHASEORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;

            PurchasePay purchasePay = new PurchasePay();
            purchasePay.setCreateTime(forObject.getFDATE());
            purchasePay.setEndTime(forObject.getFENDDATE());
            purchasePay.setOrgId(forgid.getOrgId());
            purchasePay.setPayableNumber(String.format("%.2f",forObject.getFALLAMOUNTFOR()));
            purchasePay.setPayableObject(forObject.getGysName());
            purchasePay.setPurchaseMaterial(forObject.getFNAME());
            purchasePay.setPurchaseNumber(String.format("%.2f",forObject.getFPriceQty()));
            purchasePay.setPrice(String.format("%.2f",forObject.getFPrice() ));
            purchasePay.setFTaxPrice(String.format("%.2f",forObject.getFTaxPrice() ));

            purchasePay.setFBILLNO(forObject.getFBILLNO());
            purchasePay.setFPURCHASEORGID(forObject.getFPURCHASEORGID());
            purchasePay.setFPAYORGID(forObject.getFPAYORGID());
            purchasePay.setFSUPPLIERID(forObject.getFSUPPLIERID());
            purchasePay.setFSourceBillNo(forObject.getFSourceBillNo());
            purchasePay.setFBGLCONTRACTL(forObject.getFBGLCONTRACTL());
            purchasePay.setFMATERIALID(forObject.getFMATERIALID());
            purchasePay.setFOrderEntryID(forObject.getFOrderEntryID());
            purchasePay.setFSPECIFICATION(forObject.getFSPECIFICATION());
            payMapper.insert(purchasePay);

        }
    }

     @Override
    public void  getCaiGouHeTongShuLiangJinE(Date date){
        ResponseEntity<List<CaiGouDingDanShuLiangJinE>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-caiGou/getCaiGouHeTongShuLiangJinE?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<CaiGouDingDanShuLiangJinE>>() {}
        );
        List<CaiGouDingDanShuLiangJinE> forObjects = response.getBody();
        System.out.println(forObjects);

        for (CaiGouDingDanShuLiangJinE forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFPURCHASEORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            PurchaseContract purchaseContract = new PurchaseContract();
            purchaseContract.setContractMoney(String.format("%.2f",forObject.getFALLAMOUNT()));
            purchaseContract.setCreateTime(forObject.getFDATE());
            purchaseContract.setMaterialNumber(String.format("%.2f",forObject.getFQTY()));
            purchaseContract.setMaterialType(forObject.getFname());
            purchaseContract.setOrgId(forgid.getOrgId());
            purchaseContract.setOrderType(getHeTongType(forObject.getDingDanType()));
            purchaseContract.setFnumber(forObject.getFnumber());
            purchaseContract.setContractOrder(forObject.getFBILLNO());

            contractMapper.insert(purchaseContract);
        }

    }

}
