package vip.xiaonuo.erp.service.impl;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.ParameterizedTypeReference;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;
import vip.xiaonuo.erp.entity.ErpBdOrg;
import vip.xiaonuo.erp.entity.caigou.*;
import vip.xiaonuo.erp.entity.center.CaiGouJinE;
import vip.xiaonuo.erp.entity.center.DangQianYvQi;
import vip.xiaonuo.erp.entity.center.XiaoShouE;
import vip.xiaonuo.erp.entity.center.YangMaoZhiCaiGouJinE;
import vip.xiaonuo.erp.entity.voucher.ChanPinShouRu;
import vip.xiaonuo.erp.entity.voucher.ErpVoucher;
import vip.xiaonuo.erp.entity.voucher.JingLiRunQuShi;
import vip.xiaonuo.erp.entity.voucher.LinJinHuanKuanQi;
import vip.xiaonuo.erp.mapper.ErpBdOrgMapper;
import vip.xiaonuo.erp.service.IErpCaiWuService;
import vip.xiaonuo.erp.service.IErpHeXinService;
import vip.xiaonuo.money.entity.MoneyBusiness;
import vip.xiaonuo.money.entity.MoneyProduce;
import vip.xiaonuo.money.entity.MoneyProduce0422;
import vip.xiaonuo.money.entity.MoneyProduceIncome;
import vip.xiaonuo.money.mapper.*;

import java.util.Date;
import java.util.List;


@Service
public class ErpCaiWuServiceImpl implements IErpCaiWuService {
    @Autowired
    private RestTemplate restTemplate;
    @Autowired
    private ErpBdOrgMapper erpBdOrgMapper;
    @Autowired
    private MoneyBusinessMapper businessMapper;

    @Autowired
    private MoneyBorrowWarningMapper borrowWarningMapper;
    @Autowired
    private MoneyProduceMapper produceMapper;
    @Autowired
    private MoneyProduceIncomeMapper produceIncomeMapper;


   @Override
    public void  getShouRuJinE(Date date){
        ResponseEntity<List<ErpVoucher>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-voucher/getShouRuJinE?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<ErpVoucher>>() {}
        );
        List<ErpVoucher> forObjects = response.getBody();
        System.out.println(forObjects);
        for (ErpVoucher forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFacctorgid()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            MoneyBusiness moneyBusiness = new MoneyBusiness();
            moneyBusiness.setOrgId(forgid.getOrgId());
            moneyBusiness.setCreateTime(forObject.getFDATE());
            moneyBusiness.setBusinessIncome(String.format("%.2f",forObject.getFcredit()));
            businessMapper.insert(moneyBusiness);
        }
    }

    @Override
    public void  getDangQianYueYingYeE(Date date){
        ResponseEntity<List<ErpVoucher>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-voucher/getDangQianYueYingYeE?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<ErpVoucher>>() {}
        );
        List<ErpVoucher> forObjects = response.getBody();
        System.out.println(forObjects);
        for (ErpVoucher forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFacctorgid()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            MoneyBusiness moneyBusiness = new MoneyBusiness();
            moneyBusiness.setOrgId(forgid.getOrgId());
            moneyBusiness.setCreateTime(forObject.getFDATE());
            moneyBusiness.setBusinessCost(String.format("%.2f",forObject.getFcredit()));
            businessMapper.insert(moneyBusiness);
        }
    }
   @Override
    public void  getDangQianYueJingLiRun(Date date){
        ResponseEntity<List<ErpVoucher>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-voucher/getDangQianYueJingLiRun?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<ErpVoucher>>() {}
        );
        List<ErpVoucher> forObjects = response.getBody();
        System.out.println(forObjects);
        for (ErpVoucher forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFacctorgid()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            MoneyBusiness moneyBusiness = new MoneyBusiness();
            moneyBusiness.setOrgId(forgid.getOrgId());
            moneyBusiness.setCreateTime(forObject.getFDATE());
            moneyBusiness.setProfit(String.format("%.2f",forObject.getFcredit()));
            businessMapper.insert(moneyBusiness);
        }
    }
   @Override
    public void  getDangQianZiJinYvE(Date date){
        ResponseEntity<List<ErpVoucher>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-voucher/getDangQianZiJinYvE?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<ErpVoucher>>() {}
        );
        List<ErpVoucher> forObjects = response.getBody();
        System.out.println(forObjects);
        for (ErpVoucher forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFacctorgid()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            MoneyBusiness moneyBusiness = new MoneyBusiness();
            moneyBusiness.setOrgId(forgid.getOrgId());
            String yearperiod = forObject.getYearperiod();

            moneyBusiness.setCreateTime( DateUtil.parse(yearperiod,"yyyyMM"));
            moneyBusiness.setBalance(String.format("%.2f",forObject.getEndBalance()));
            businessMapper.insert(moneyBusiness);
        }
    }

    @Autowired
    private MoneyProduce0422Mapper moneyProduce0422Mapper;


   @Override
    public void  getChanPinShouRu(String date){
        ResponseEntity<List<ChanPinShouRu>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-voucher/getChanPinShouRu?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<ChanPinShouRu>>() {}
        );
        //'50万IU/G饲料添加剂VD3微粒','NF级胆固醇','饲料级胆固醇91%',
        // '25-羟基VD3原','4000万IU/G胆钙化醇',
        // '维生素D3原','蜡丸','100万IU/G复配营养强化剂MO','饲料级胆固醇80%','化妆品级羊毛醇'
        List<ChanPinShouRu> forObjects = response.getBody();
        for (ChanPinShouRu forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFuseorgid()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            Date yearperiod = DateUtil.parse(forObject.getYearperiod(), "yyyyMM");
            MoneyProduce0422 moneyProduce = new MoneyProduce0422();
            moneyProduce.setOrgId(forgid.getOrgId());
            moneyProduce.setCreateTime(yearperiod);
            moneyProduce.setMaterialName(forObject.getFname());
            if (ObjectUtil.isNotEmpty(forObject.getFcredit())){
                moneyProduce.setMaterialAmount(String.format("%.2f",forObject.getFcredit()));
            }
            if (ObjectUtil.isNotEmpty(forObject.getFcreditqty())){
                moneyProduce.setMaterialQty(String.format("%.2f",forObject.getFcreditqty()));
            }

            moneyProduce.setMaterialType(getMaterType(forObject.getFname()));
            moneyProduce0422Mapper.insert(moneyProduce);


            MoneyProduceIncome moneyProduceIncome = new MoneyProduceIncome();
            moneyProduceIncome.setOrgId(forgid.getOrgId());
            moneyProduceIncome.setCreateTime(yearperiod);

            if ("NF级胆固醇".equals(forObject.getFname())){
                moneyProduceIncome.setNfCholesterol(String.format("%.2f",forObject.getFcredit()));
            }else if (forObject.getFname().contains("饲料级胆固醇")){
                moneyProduceIncome.setBreedCholesterol(String.format("%.2f",forObject.getFcredit()));
            }else if (forObject.getFname().contains("化妆品级羊毛醇")){
                moneyProduceIncome.setSheepAlcohol(String.format("%.2f",forObject.getFcredit()));
            }else {
                moneyProduceIncome.setOther(String.format("%.2f",forObject.getFcredit()));
            }
            produceIncomeMapper.insert(moneyProduceIncome);
        }
    }

    private Integer getMaterType(String fname) {
        if ("NF级胆固醇".equals(fname)){
            return 0;
        }
        if ("羊毛酸异丙酯".equals(fname)){
            return 4;
        }
        if (fname.contains( "饲料级胆固醇")){
            return 1;
        }
        if (fname.contains( "羊毛醇")){
            return 2;
        }
        if (fname.contains( "羊毛酸")){
            return 3;
        }
        return 5;
    }

   @Override
    public void  getGuoNeiWaiSouRu(Date date){
        ResponseEntity<List<ErpVoucher>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-voucher/getGuoNeiWaiSouRu?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<ErpVoucher>>() {}
        );

        //'国内销售收入','国内销售收入2','国外销售收入'
        List<ErpVoucher> forObjects = response.getBody();
        for (ErpVoucher forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFacctorgid()));
            if (ObjectUtil.isEmpty(forgid))
                continue;

            MoneyProduce moneyProduce = new MoneyProduce();
            moneyProduce.setOrgId(forgid.getOrgId());
            moneyProduce.setCreateTime(forObject.getFDATE());
            if ("国内销售收入".equals(forObject.getFNAME())||"国内销售收入2".equals(forObject.getFNAME())){
                moneyProduce.setInMoney(String.format("%.2f",forObject.getFcredit()));
            } else {
                moneyProduce.setOutMoney(String.format("%.2f",forObject.getFcredit()));
            }
            produceMapper.insert(moneyProduce);
        }
    }
}
