package vip.xiaonuo.erp.service.impl;

import cn.hutool.core.date.DateUnit;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.ParameterizedTypeReference;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;
import vip.xiaonuo.erp.entity.*;
import vip.xiaonuo.erp.entity.fengkong.FengKongKuanDao;
import vip.xiaonuo.erp.entity.voucher.ErpMaterial;
import vip.xiaonuo.erp.mapper.*;
import vip.xiaonuo.erp.service.IErpFengKongService;
import vip.xiaonuo.erp.service.IErpZhiLiangService;
import vip.xiaonuo.production.entity.ProduceLocation;
import vip.xiaonuo.production.mapper.ProduceLocationMapper;
import vip.xiaonuo.quality.entity.ErpBdQuail;
import vip.xiaonuo.quality.entity.QualityFenxibaogao;
import vip.xiaonuo.quality.entity.QualityReagentStock;
import vip.xiaonuo.quality.entity.vo.ErpQualiQm;
import vip.xiaonuo.quality.mapper.ErpBdQuailMapper;
import vip.xiaonuo.quality.mapper.QualityFenxibaogaoMapper;
import vip.xiaonuo.quality.mapper.QualityReagentStockMapper;
import vip.xiaonuo.risk.entity.RiskContract;
import vip.xiaonuo.risk.entity.RiskContractWarning;
import vip.xiaonuo.risk.mapper.RiskContractMapper;
import vip.xiaonuo.risk.mapper.RiskContractWarningMapper;
import vip.xiaonuo.sale.entity.SaleReceive;
import vip.xiaonuo.sale.mapper.SaleReceiveMapper;

import java.util.Date;
import java.util.List;


@Service
public class ErpFengKongServiceImpl implements IErpFengKongService {

    @Autowired
    private RestTemplate restTemplate;
    @Autowired
    private ErpBdOrgMapper erpBdOrgMapper;
    @Autowired
    private RiskContractMapper riskContractMapper;
    @Autowired
    private RiskContractWarningMapper warningMapper;

    //风控款到发货
     @Override
    public void  getKuanDaoFaHuo(Date date){
        ResponseEntity<List<FengKongKuanDao>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-fengKong/getKuanDaoFaHuo?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<FengKongKuanDao>>() {}
        );
        List<FengKongKuanDao> forObjects = response.getBody();
        for (FengKongKuanDao erpMaterial : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", erpMaterial.getFSALEORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            RiskContract riskContract = new RiskContract();
            riskContract.setAllmount(erpMaterial.getFALLAMOUNT());
            riskContract.setContractOrder(erpMaterial.getFBILLNO());
            riskContract.setCreateTime(erpMaterial.getFDATE());
            riskContract.setDeliverTime(erpMaterial.getChukuDate());
            riskContract.setEndTime(erpMaterial.getFDELIVERYDATE());
            riskContract.setFname(erpMaterial.getFNAME());
            riskContract.setKehu(erpMaterial.getKeHuName());
            riskContract.setOrgId(forgid.getOrgId());
            riskContract.setQty(erpMaterial.getFQTY());
            riskContract.setOverdueDay(getDay(erpMaterial.getFDELIVERYDATE(),erpMaterial.getChukuDate()));
            riskContractMapper.insert(riskContract);
        }

    }


    @Autowired
    private SaleReceiveMapper saleReceiveMapper;

    //风控逾期合同
     @Override
    public void  getCaiGouYvQi(Date date){
        ResponseEntity<List<FengKongKuanDao>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-fengKong/getCaiGouYvQi?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<FengKongKuanDao>>() {}
        );
        List<FengKongKuanDao> forObjects = response.getBody();
        for (FengKongKuanDao erpMaterial : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", erpMaterial.getFSALEORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            //风控
            RiskContractWarning riskContract = new RiskContractWarning();

            riskContract.setAllmount(erpMaterial.getFALLAMOUNT());
            riskContract.setContractOrder(erpMaterial.getFBILLNO());
            riskContract.setCreateTime(erpMaterial.getFDATE());
            riskContract.setOverdueTime(erpMaterial.getFDELIVERYDATE());
//            riskContract.setEndTime(erpMaterial.getFDELIVERYDATE());
            riskContract.setFname(erpMaterial.getFNAME());
            riskContract.setCustomer(erpMaterial.getKeHuName());
            riskContract.setKehu(erpMaterial.getKeHuName());
            riskContract.setOrgId(forgid.getOrgId());
            riskContract.setQty(erpMaterial.getFQTY());
            riskContract.setChuku(erpMaterial.getChukuDate());
            riskContract.setOverdueMoney(""+
                    erpMaterial.getFALLAMOUNT());

            warningMapper.insert(riskContract);
            //销售
            SaleReceive saleReceive = new SaleReceive();
            saleReceive.setCreateTime(erpMaterial.getFDATE());
            saleReceive.setOrgId(forgid.getOrgId());
            saleReceive.setPaymentMoney(String.format("%.2f",erpMaterial.getFALLAMOUNT()));
            Integer day = getDay(erpMaterial.getFDELIVERYDATE(), erpMaterial.getChukuDate());

            saleReceive.setReceiveDay(day+"");

            if(day<=0){
                saleReceive.setReceiveMoney(String.format("%.2f",erpMaterial.getFALLAMOUNT()));

            }
            saleReceive.setReceiveOrder(erpMaterial.getFBILLNO());

            saleReceiveMapper.insert(saleReceive);

        }

    }
    private  Integer getDay(Date start ,Date endDate){

        if (ObjectUtil.isNotEmpty(start)&&ObjectUtil.isNotEmpty(endDate)){
            // 计算两个日期之间相差的天数（带正负号）
            long betweenDays = DateUtil.between(start, endDate, DateUnit.DAY);
            // 判断日期的先后顺序，决定正负号
            if ( start.before(endDate)) {
                return (int)betweenDays;
            }
        }
        return 0;
    }



}
