package vip.xiaonuo.erp.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.ParameterizedTypeReference;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;
import vip.xiaonuo.erp.entity.ErpBdOrg;
import vip.xiaonuo.erp.entity.kucun.*;
import vip.xiaonuo.erp.entity.shengcan.ShiJiChanLiang;
import vip.xiaonuo.erp.mapper.ErpBdOrgMapper;
import vip.xiaonuo.erp.service.IErpKuCunService;
import vip.xiaonuo.erp.service.IErpShengChanService;
import vip.xiaonuo.production.entity.ProductionTarget;
import vip.xiaonuo.production.entity.ProductionWorkstopPlan;
import vip.xiaonuo.production.entity.ProductionYield;
import vip.xiaonuo.production.mapper.ProductionTargetMapper;
import vip.xiaonuo.production.mapper.ProductionWorkstopPlanMapper;
import vip.xiaonuo.production.mapper.ProductionYieldMapper;

import java.util.Date;
import java.util.List;


@Service
public class ErpShengChanServiceImpl implements IErpShengChanService {
    @Autowired
    private RestTemplate restTemplate;
    @Autowired
    private ErpBdOrgMapper erpBdOrgMapper;
    @Autowired
    private ProductionYieldMapper yieldMapper;

    @Autowired
    private ProductionWorkstopPlanMapper workstopPlanMapper;

    @Autowired
    private ProductionTargetMapper targetMapper;
    @Override
    public void  getShiJiChanLiang(Date date){
        ResponseEntity<List<ShiJiChanLiang>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-shengChan/getShiJiChanLiang?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<ShiJiChanLiang>>() {}
        );
        List<ShiJiChanLiang> forObjects = response.getBody();

        for (ShiJiChanLiang forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFSTOCKORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            ProductionYield productionYield = new ProductionYield();
            productionYield.setActualProduction(String.format("%.2f",forObject.getFREALQTY()));
            productionYield.setCompanyName(forgid.getFname());
//            productionYield.setCompleteRate();
            productionYield.setCreateTime(forObject.getFDATE());
            productionYield.setLocationName(forObject.getCheJianName());
            productionYield.setOrgId(forgid.getOrgId());
            productionYield.setProduceName(forObject.getWuLiaoName());
            yieldMapper.insert(productionYield);

            ProductionWorkstopPlan productionWorkstopPlan  = new ProductionWorkstopPlan();
            productionWorkstopPlan.setActualProduction(String.format("%.2f",forObject.getFREALQTY()));
//            productionWorkstopPlan.setAvgValue();
            productionWorkstopPlan.setCreateTime(forObject.getFDATE());
            productionWorkstopPlan.setLocationId(forObject.getFWORKSHOPID()+"");
            productionWorkstopPlan.setLocationName(forObject.getCheJianName());
            productionWorkstopPlan.setOrgId(forgid.getOrgId());
//            productionWorkstopPlan.setPlanProduction();
            productionWorkstopPlan.setProduceName(forObject.getWuLiaoName());
//            productionWorkstopPlan.setUnitCost();
            workstopPlanMapper.insert(productionWorkstopPlan);

            ProductionTarget productionTarget = new ProductionTarget();
            productionTarget.setActualProduction(String.format("%.2f",forObject.getFREALQTY()));
            productionTarget.setCreateTime(forObject.getFDATE());
            productionTarget.setLocationName(forObject.getCheJianName());
            productionTarget.setOrgId(forgid.getOrgId());
//            productionTarget.setPlanCompleteRate();
//            productionTarget.setPlanProduction();
//            productionTarget.setProductionEnergy();
//            productionTarget.setReceiveRate();
            targetMapper.insert(productionTarget);
        }
    }
}
