package vip.xiaonuo.erp.service.impl;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.ParameterizedTypeReference;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;
import vip.xiaonuo.erp.entity.ErpBdOrg;
import vip.xiaonuo.erp.entity.shengcan.ShiJiChanLiang;
import vip.xiaonuo.erp.entity.xiaoshou.*;
import vip.xiaonuo.erp.mapper.ErpBdOrgMapper;
import vip.xiaonuo.erp.service.IErpShengChanService;
import vip.xiaonuo.erp.service.IErpXiaoShouService;
import vip.xiaonuo.money.entity.MoneyCost;
import vip.xiaonuo.money.entity.MoneyOverdue;
import vip.xiaonuo.money.entity.MoneyWriteOverdue;
import vip.xiaonuo.money.mapper.MoneyCostMapper;
import vip.xiaonuo.money.mapper.MoneyOverdueMapper;
import vip.xiaonuo.money.mapper.MoneyWriteOverdueMapper;
import vip.xiaonuo.sale.entity.*;
import vip.xiaonuo.sale.mapper.*;

import java.util.Date;
import java.util.List;


@Service
public class ErpXiaoShouServiceImpl implements IErpXiaoShouService {
    @Autowired
    private RestTemplate restTemplate;
    @Autowired
    private SaleDetailMapper detailMapper;
    @Autowired
    private ErpBdOrgMapper erpBdOrgMapper;

    @Autowired
    private SaleCustomerMapper customerMapper;
    @Autowired
    private SaleCostMapper costMapper;

    @Autowired
    private SaleDeliverMapper deliverMapper;
    @Autowired
    private SaleInvoiceMapper invoiceMapper;

    @Autowired
    private SaleOverdueMapper overdueMapper;
    @Autowired
    private SalePriceMapper priceMapper;
    @Autowired
    private SaleProduceMapper produceMapper;

    @Autowired
    private SaleOrderMapper orderMapper;
    @Autowired
    private MoneyCostMapper moneyCostMapper;


    @Autowired
    private SaleTargetMapper targetMapper;

    @Autowired
    private MoneyOverdueMapper moneyOverdueMapper;
    @Autowired
    private SaleSalesmanMapper salesmanMapper;
    @Autowired
    private MoneyWriteOverdueMapper moneyWriteOverdueMapper;


    @Override
    public void getWanChengLv(Date date) {
        ResponseEntity<List<XiaoShouWanChenLvJinE>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-XiaoShou/getWanChengLv?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<XiaoShouWanChenLvJinE>>() {
                }
        );
        List<XiaoShouWanChenLvJinE> forObjects = response.getBody();
        System.out.println(forObjects);
        for (XiaoShouWanChenLvJinE forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFSALEORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            SaleDetail saleDetail = new SaleDetail();
            saleDetail.setCreateTime(forObject.getFDATE());
            saleDetail.setCustomer(forObject.getKeHuName());
            saleDetail.setOrgId(forgid.getOrgId());
            saleDetail.setProduceName(forObject.getWuLiaoName());
            saleDetail.setSaleContraceOrder(forObject.getFBILLNO());
            saleDetail.setSaleMoney(String.format("%.2f", forObject.getFALLAMOUNTLC()));
            saleDetail.setSaleNumber(String.format("%.2f", forObject.getFQTY()));
            saleDetail.setSalesman(forObject.getFNAME());

            saleDetail.setCurrencyId(forObject.getFSettleCurrId());
            saleDetail.setTaxPrice(String.format("%.2f",forObject.getFTaxPrice()));
            saleDetail.setAllAmonunt(String.format("%.2f",forObject.getFBillAllAmount()));
            saleDetail.setFentryid(forObject.getFentryid());
            detailMapper.insert(saleDetail);


            SaleCustomer saleCustomer = new SaleCustomer();
            saleCustomer.setCreateTime(forObject.getFDATE());
            saleCustomer.setCustomer(forObject.getKeHuName());
            saleCustomer.setSaleMoney(String.format("%.2f", forObject.getFALLAMOUNTLC()));
            saleCustomer.setOrgId(forgid.getOrgId());
            customerMapper.insert(saleCustomer);

            SalePrice salePrice = new SalePrice();
            salePrice.setCreateTime(forObject.getFDATE());
            salePrice.setOrgId(forgid.getOrgId());
            salePrice.setPrice(String.format("%.4f", forObject.getXiaoShouDanJia()));
            salePrice.setProduceName(forObject.getWuLiaoName());
            priceMapper.insert(salePrice);

            SaleProduce saleProduce = new SaleProduce();
            saleProduce.setCreateTime(forObject.getFDATE());
            saleProduce.setOrgId(forgid.getOrgId());
            saleProduce.setPrice(String.format("%.4f", forObject.getXiaoShouDanJia()));
            saleProduce.setProduceName(forObject.getWuLiaoName());
            saleProduce.setSaleMoney(String.format("%.2f", forObject.getFALLAMOUNTLC()));
            produceMapper.insert(saleProduce);

        }
    }

    //订单金额
    @Override
    public void getDingDan(Date date) {

        //
        ResponseEntity<List<XiaoShouWanChenLvJinE>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-XiaoShou/getDingDan?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<XiaoShouWanChenLvJinE>>() {
                }
        );
        List<XiaoShouWanChenLvJinE> forObjects = response.getBody();
        System.out.println(forObjects);
        for (XiaoShouWanChenLvJinE forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFSALEORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            SaleOrder saleOrder = new SaleOrder();
            saleOrder.setCreateTime(forObject.getFDATE());
            saleOrder.setOrgId(forgid.getOrgId());
            saleOrder.setSaleMoney(String.format("%.2f", forObject.getFALLAMOUNTLC()));
            saleOrder.setSaleNumber(String.format("%.2f", forObject.getFQTY()));
            saleOrder.setSaleOrder(forObject.getFBILLNO());

            saleOrder.setCustomer(forObject.getKeHuName());
            saleOrder.setSalesman(forObject.getFNAME());
            saleOrder.setProduceName(forObject.getWuLiaoName());
            saleOrder.setCurrencyId(forObject.getFSettleCurrId());
            saleOrder.setAllAmonunt(getStringDouble(forObject.getFBillAllAmount()));
            saleOrder.setTaxPrice(getStringDouble(forObject.getFTaxPrice()));
            saleOrder.setContractId(forObject.getFentryid());


            orderMapper.insert(saleOrder);
        }
    }
    private  String getStringDouble(Double d){
        if (null == d){
            return "0";
        }
        return String.format("%.2f",d);
    }

    @Override
    public void getXiaoShouFeiYong2(Date date) {

        // 销售费用，管理费用，财务费用，研发费用
        ResponseEntity<List<XiaoShouFeiYong>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-XiaoShou/getXiaoShouFeiYong?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<XiaoShouFeiYong>>() {
                }
        );
        List<XiaoShouFeiYong> forObjects = response.getBody();
        System.out.println(forObjects);
        for (XiaoShouFeiYong forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFacctorgid()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            SaleCost saleCost = new SaleCost();
            saleCost.setCreateTime(forObject.getFDATE());
            saleCost.setOrgId(forgid.getOrgId());
            saleCost.setSaleCostMoney(String.format("%.2f",forObject.getFCREDIT()));
            saleCost.setSaleCostName(forObject.getFname());
            costMapper.insert(saleCost);
            MoneyCost moneyCost = new MoneyCost();
            moneyCost.setCreateTime(forObject.getFDATE());
            moneyCost.setOrgId(forgid.getOrgId());
            moneyCost.setSale(String.format("%.2f", forObject.getFCREDIT()));
            moneyCost.setCompany(forgid.getFname());
            moneyCostMapper.insert(moneyCost);
        }


    }

    @Override
    public void getXiaoShouFeiYong21(Date date) {

        // 销售费用，管理费用，财务费用，研发费用
        ResponseEntity<List<XiaoShouFeiYong>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-XiaoShou/getXiaoShouFeiYong2?number=6601&date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<XiaoShouFeiYong>>() {
                }
        );
        List<XiaoShouFeiYong> forObjects = response.getBody();
        System.out.println(forObjects);
        for (XiaoShouFeiYong forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFacctorgid()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            MoneyCost moneyCost = new MoneyCost();
            moneyCost.setCreateTime(forObject.getFDATE());
            moneyCost.setOrgId(forgid.getOrgId());
            moneyCost.setSale(String.format("%.2f", forObject.getFCREDIT()));
            moneyCost.setCompany(forgid.getFname());
            moneyCost.setFname(forObject.getFname());
            moneyCostMapper.insert(moneyCost);
        }
    }

    @Override
    public void getXiaoShouFeiYong22(Date date) {

        // 销售费用，管理费用，财务费用，研发费用
        ResponseEntity<List<XiaoShouFeiYong>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-XiaoShou/getXiaoShouFeiYong2?number=6602&date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<XiaoShouFeiYong>>() {
                }
        );
        List<XiaoShouFeiYong> forObjects = response.getBody();
        System.out.println(forObjects);
        for (XiaoShouFeiYong forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFacctorgid()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            MoneyCost moneyCost = new MoneyCost();
            moneyCost.setCreateTime(forObject.getFDATE());
            moneyCost.setOrgId(forgid.getOrgId());
            moneyCost.setManage(String.format("%.2f", forObject.getFCREDIT()));
            moneyCost.setCompany(forgid.getFname());
            moneyCost.setFname(forObject.getFname());
            moneyCostMapper.insert(moneyCost);
        }
    }

    @Override
    public void getXiaoShouFeiYong23(Date date) {

        // 销售费用，管理费用，财务费用，研发费用
        ResponseEntity<List<XiaoShouFeiYong>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-XiaoShou/getXiaoShouFeiYong2?number=6603&date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<XiaoShouFeiYong>>() {
                }
        );
        List<XiaoShouFeiYong> forObjects = response.getBody();
        System.out.println(forObjects);
        for (XiaoShouFeiYong forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFacctorgid()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            MoneyCost moneyCost = new MoneyCost();
            moneyCost.setCreateTime(forObject.getFDATE());
            moneyCost.setOrgId(forgid.getOrgId());
            moneyCost.setFinance(String.format("%.2f", forObject.getFCREDIT()));
            moneyCost.setCompany(forgid.getFname());
            moneyCost.setFname(forObject.getFname());
            moneyCostMapper.insert(moneyCost);
        }
    }

    @Override
    public void getXiaoShouFeiYong24(Date date) {

        // 销售费用，管理费用，财务费用，研发费用
        ResponseEntity<List<XiaoShouFeiYong>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-XiaoShou/getXiaoShouFeiYong2?number=6605&date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<XiaoShouFeiYong>>() {
                }
        );
        List<XiaoShouFeiYong> forObjects = response.getBody();
        System.out.println(forObjects);
        for (XiaoShouFeiYong forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFacctorgid()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            MoneyCost moneyCost = new MoneyCost();
            moneyCost.setCreateTime(forObject.getFDATE());
            moneyCost.setOrgId(forgid.getOrgId());
            moneyCost.setResearch(String.format("%.2f", forObject.getFCREDIT()));
            moneyCost.setCompany(forgid.getFname());
            moneyCost.setFname(forObject.getFname());
            moneyCostMapper.insert(moneyCost);
        }
    }

    @Override
    public void getXiaoShouFaHuoJinEKeHuGongXian(Date date) {
        ResponseEntity<List<XiaoShouFaHuoJinEKeHuGongXian>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-XiaoShou/getXiaoShouFaHuoJinEKeHuGongXian?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<XiaoShouFaHuoJinEKeHuGongXian>>() {
                }
        );
        List<XiaoShouFaHuoJinEKeHuGongXian> forObjects = response.getBody();
        for (XiaoShouFaHuoJinEKeHuGongXian forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFSTOCKORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            SaleDeliver saleDeliver = new SaleDeliver();
            saleDeliver.setCreateTime(forObject.getFDATE());
            saleDeliver.setOrgId(forgid.getOrgId());
            saleDeliver.setSaleDeliverMoney(String.format("%.2f", forObject.getFALLAMOUNTLC()));
            saleDeliver.setSaleDeliverNumber(String.format("%.2f", forObject.getFREALQTY()));
            saleDeliver.setSaleOrder(forObject.getFBILLNO());

            saleDeliver.setSaleNumber(getStringDouble(forObject.getFREALQTY()));
            saleDeliver.setProduceName(forObject.getWuLiaoName());
            saleDeliver.setCurrencyId(forObject.getFSettleCurrId());
            saleDeliver.setAllAmonunt(getStringDouble(forObject.getFBillAmount()));
            saleDeliver.setSorrDerno(forObject.getFSoorDerno());
            saleDeliver.setCustomer(forObject.getFNAME());
            saleDeliver.setSalesman(forObject.getXiaoShouName());
            deliverMapper.insert(saleDeliver);
            SaleSalesman saleSalesman = new SaleSalesman();
            saleSalesman.setCreateTime(forObject.getFDATE());
            saleSalesman.setOrgId(forgid.getOrgId());
            saleSalesman.setSalesmanMoney(String.format("%.2f", forObject.getFALLAMOUNTLC()));
            saleSalesman.setSalesmanName(forObject.getXiaoShouName());
            salesmanMapper.insert(saleSalesman);
        }

    }

    @Override
    public void getXiaoShouFaPiaoJinE(Date date) {
        ResponseEntity<List<XiaoShouFaPiaoJinE>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-XiaoShou/getXiaoShouFaPiaoJinE?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<XiaoShouFaPiaoJinE>>() {
                }
        );
        List<XiaoShouFaPiaoJinE> forObjects = response.getBody();
        for (XiaoShouFaPiaoJinE forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFSALEORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            SaleInvoice saleInvoice = new SaleInvoice();
            saleInvoice.setCreateTime(forObject.getFDATE());
            saleInvoice.setOrgId(forgid.getOrgId());
            saleInvoice.setSaleInvoiceMoney(String.format("%.2f", forObject.getFALLAMOUNT()));
            saleInvoice.setSaleInvoiceOrder(forObject.getFBILLNO());
            invoiceMapper.insert(saleInvoice);

        }
    }

    @Override
    public void getYvQiHeTongMingXi(Date date) {
        ResponseEntity<List<YvQiHeTongMingXi>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-XiaoShou/getYvQiHeTongMingXi?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<YvQiHeTongMingXi>>() {
                }
        );
        List<YvQiHeTongMingXi> forObjects = response.getBody();
        for (YvQiHeTongMingXi forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFSALEORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            SaleOverdue saleOverdue = new SaleOverdue();
            saleOverdue.setCreateTime(forObject.getFCREATEDATE());
            saleOverdue.setDeliveryDate(forObject.getChuKuDate());
            saleOverdue.setDeliveryNumber(forObject.getFQTY());
            saleOverdue.setOrgId(forgid.getOrgId());
//            saleOverdue.setOverdueDay();
            saleOverdue.setOverdueMoney(String.format("%.2f", forObject.getFALLAMOUNTLC()));
            saleOverdue.setOverdueOrder(forObject.getFBILLNO());
            overdueMapper.insert(saleOverdue);

        }
    }
    //== 改过的
    @Override
    public void getCaiWuYingShou(String date) {
        ResponseEntity<List<CaiWuYingShou>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-XiaoShou/getCaiWuYingShou?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<CaiWuYingShou>>() {
                }
        );
        List<CaiWuYingShou> forObjects = response.getBody();
        for (CaiWuYingShou forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFUSEORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            MoneyOverdue moneyProduce = new MoneyOverdue();
            moneyProduce.setCollectPrice(String.format("%.2f", forObject.getFENDBALANCEFOR()));
            moneyProduce.setDateTime( DateUtil.parse(forObject.getFyearperiod(),"yyyyMM") );
            moneyProduce.setDocumentNumber(forObject.getFACCOUNTBOOKID()+"");
            moneyProduce.setIsOverdue(0);
            moneyProduce.setOrgId(forgid.getOrgId());
            moneyProduce.setOverduePrice("0");
            moneyProduce.setUserName(forObject.getFNAME());

            moneyOverdueMapper.insert(moneyProduce);

            MoneyWriteOverdue moneyWriteOverdue = new MoneyWriteOverdue();
            moneyWriteOverdue.setUserName(forObject.getFNAME());
            moneyWriteOverdue.setBz("人民币");
            moneyWriteOverdue.setOrgId(forgid.getOrgId());
            moneyWriteOverdue.setYbje(String.format("%.2f", forObject.getFENDBALANCEFOR()));
            moneyWriteOverdue.setRmbje(String.format("%.2f", forObject.getFENDBALANCEFOR()));
            moneyWriteOverdue.setXsrq( DateUtil.parse(forObject.getFyearperiod(),"yyyyMM"));
            moneyWriteOverdue.setCreateTime( DateUtil.parse(forObject.getFyearperiod(),"yyyyMM"));
            moneyWriteOverdue.setYqts( "0");
            moneyWriteOverdue.setDocumentType("0");
            moneyWriteOverdue.setEndTime(DateUtil.parse(forObject.getFyearperiod(),"yyyyMM"));

            moneyWriteOverdueMapper.insert(moneyWriteOverdue);
        }

    }




    private String getNum(BaiFangKeHu forObject) {
        if (StringUtils.isBlank(forObject.getFZCREMARKS2())){
            return "1";
        }else if (StringUtils.isBlank(forObject.getFZCREMARKS3())){
            return "2";
        } else if (StringUtils.isBlank(forObject.getFZCREMARKS4())){
            return "3";
        }else if (StringUtils.isNotBlank(forObject.getFZCREMARKS4())){
            return "4";
        }else {
            return "1";
        }
    }
}
