package vip.xiaonuo.erp.service.impl;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.ParameterizedTypeReference;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;
import vip.xiaonuo.erp.entity.*;
import vip.xiaonuo.erp.entity.voucher.ErpMaterial;
import vip.xiaonuo.erp.entity.xiaoshou.*;
import vip.xiaonuo.erp.mapper.*;
import vip.xiaonuo.erp.service.IErpXiaoShouService;
import vip.xiaonuo.erp.service.IErpZhiLiangService;
import vip.xiaonuo.production.entity.ProduceLocation;
import vip.xiaonuo.production.mapper.ProduceLocationMapper;
import vip.xiaonuo.quality.entity.ErpBdQuail;
import vip.xiaonuo.quality.entity.QualityFenxibaogao;
import vip.xiaonuo.quality.entity.QualityReagentStock;
import vip.xiaonuo.quality.entity.vo.ErpQualiQm;
import vip.xiaonuo.quality.mapper.ErpBdQuailMapper;
import vip.xiaonuo.quality.mapper.QualityFenxibaogaoMapper;
import vip.xiaonuo.quality.mapper.QualityReagentStockMapper;

import java.util.Date;
import java.util.List;


@Service
public class ErpZhiLiangServiceImpl implements IErpZhiLiangService {
    @Autowired
    private RestTemplate restTemplate;

    @Autowired
    private ErpBdOrgMapper erpBdOrgMapper;
    @Autowired
    private ErpBdDepartmentMapper erpBdDepartmentMapper;
    @Autowired
    private QualityFenxibaogaoMapper qualityFenxibaogaoMapper;
    @Autowired
    private ProduceLocationMapper produceLocationMapper;
    @Autowired
    private ErpBdMaterialGroupMapper erpBdMaterialGroupMapper;
    @Autowired
    private ErpBdRawMaterialMapper erpBdRawMaterialMapper;
    @Autowired
    private ErpBdQuailMapper erpBdQuailMapper;
    @Autowired
    private QualityReagentStockMapper qualityReagentStockMapper;
    @Autowired
    private ErpBdMaterialMapper erpBdMaterialMapper;
    
    //获取质量 所有记录
    @Override
    public void getQuailIbit(Date date) {

        ResponseEntity<List<ErpQualiQm>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-bd-org/getQuailIbit?date="+date,
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<ErpQualiQm>>() {}
        );
        List<ErpQualiQm> forObjects = response.getBody();
        for (ErpQualiQm erpMaterial : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", erpMaterial.getFINSPECTORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;

            QualityFenxibaogao qualityFenxibaogao = new QualityFenxibaogao();
            String fworkshopid = erpMaterial.getFWORKSHOPID();
            //车间
            ErpBdDepartment fdeptid = erpBdDepartmentMapper.selectOne(new QueryWrapper<ErpBdDepartment>().eq("fdeptid", fworkshopid));

            if(ObjectUtil.isNotEmpty(fdeptid)){
                qualityFenxibaogao.setCheJianName(fdeptid.getFname());
            }
            qualityFenxibaogao.setInspecDate( erpMaterial.getInspectStartDate());
            qualityFenxibaogao.setInspecItems(erpMaterial.getFbglremarks());
            qualityFenxibaogao.setInspecNum(erpMaterial.getFBILLNO());
            qualityFenxibaogao.setInspecResults("合格");
            qualityFenxibaogao.setInspecStandards(erpMaterial.getFbgltext16());
            qualityFenxibaogao.setManufBatchNum(erpMaterial.getFLOT());
            qualityFenxibaogao.setMaterialName(erpMaterial.getFname());
            qualityFenxibaogao.setFnumber(erpMaterial.getFnumber());
            qualityFenxibaogao.setOrgId(forgid.getOrgId());

            //生产单位
            ErpBdDepartment fdeptid1 = erpBdDepartmentMapper.selectOne(new QueryWrapper<ErpBdDepartment>().eq("fdeptid", erpMaterial.getFINSPECTDEPID()));
            if(ObjectUtil.isNotEmpty(fdeptid1)){
                qualityFenxibaogao.setProductionUnit(fdeptid1.getFname());
            }

            qualityFenxibaogao.setQualityType(0);
            qualityFenxibaogao.setQuantity(erpMaterial.getFINSPECTQTY());
            qualityFenxibaogao.setReportDate(erpMaterial.getInspectEndDate());
            qualityFenxibaogao.setSelfBatchNum(erpMaterial.getFBILLNO());
            qualityFenxibaogao.setSampDate(erpMaterial.getInspectStartDate());
//            qualityFenxibaogao.setSpec();
            qualityFenxibaogao.setSpecificOtation(erpMaterial.getFbgltext20());

            qualityFenxibaogaoMapper.insert(qualityFenxibaogao);

        }
    }
    //获取车间
    @Override
    public void getCheJian() {
        List<ErpBdDepartment> erpBdDepartments = erpBdDepartmentMapper.selectList(new QueryWrapper<ErpBdDepartment>().like("fname","车间"));
        for (ErpBdDepartment erpBdDepartment : erpBdDepartments) {
            if (produceLocationMapper.exists(new QueryWrapper<ProduceLocation>().eq("location_id", erpBdDepartment.getFdeptid())))
                continue;


            ProduceLocation produceLocation = new ProduceLocation();
            produceLocation.setOrgId(erpBdDepartment.getOrgId());
            produceLocation.setLocationName(erpBdDepartment.getFname());
            produceLocation.setOrgName(erpBdDepartment.getFfullname());
            produceLocation.setLocationId(erpBdDepartment.getFdeptid());
            produceLocationMapper.insert(produceLocation);

        }
    }

    //物料分组
    @Override
    public void getMaterialGruop() {
        ResponseEntity<List<ErpBdMaterialGroup>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-bd-org/getMaterialGruop",
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<ErpBdMaterialGroup>>() {
                }
        );
        List<ErpBdMaterialGroup> forObjects = response.getBody();
        for (ErpBdMaterialGroup erpMaterial : forObjects) {
            if (erpBdMaterialGroupMapper.exists(new QueryWrapper<ErpBdMaterialGroup>().eq("fnumber", erpMaterial.getFnumber())))
             continue;

            ErpBdMaterialGroup erpBdMaterialGroup = new ErpBdMaterialGroup();
            erpBdMaterialGroup.setFfullparentid(erpMaterial.getFfullparentid());
            erpBdMaterialGroup.setFid(erpMaterial.getFid());
            erpBdMaterialGroup.setFname(erpMaterial.getFname());
            erpBdMaterialGroup.setFnumber(erpMaterial.getFnumber());
            erpBdMaterialGroup.setFparentid(erpMaterial.getFparentid());
            erpBdMaterialGroupMapper.insert(erpBdMaterialGroup);
          
        }
    }

    //获取质量检验项目
    @Override
    public void  getQuail(){
        ResponseEntity<List<ErpBdQuail>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-bd-org/getQuail",
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<ErpBdQuail>>() {}
        );
        List<ErpBdQuail> forObjects = response.getBody();
        for (ErpBdQuail erpMaterial : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", erpMaterial.getFuseorgid()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            erpMaterial.setOrgId(forgid.getOrgId());
            erpMaterial.setCreateTime(new Date());
//            qualityReagentStock.setStock();
            erpBdQuailMapper.insert(erpMaterial);

        }

    }

    //获取试剂
    @Override
    public void  getReagent(){
        ResponseEntity<List<ErpMaterial>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-bd-org/getReagent",
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<ErpMaterial>>() {}
        );
        List<ErpMaterial> forObjects = response.getBody();
        for (ErpMaterial erpMaterial : forObjects) {

            if (qualityReagentStockMapper.exists(new QueryWrapper<QualityReagentStock>().eq("fnumber", erpMaterial.getFnumber())))
                continue;

            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", erpMaterial.getFacctorgid()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            QualityReagentStock qualityReagentStock = new QualityReagentStock();

            qualityReagentStock.setFnumber(erpMaterial.getFnumber());
            qualityReagentStock.setFspecification(erpMaterial.getFspecification());
            qualityReagentStock.setOrgId(forgid.getOrgId());
            qualityReagentStock.setOrgName(forgid.getFname());
            qualityReagentStock.setReagent(erpMaterial.getFname());
//            qualityReagentStock.setStock();
            qualityReagentStockMapper.insert(qualityReagentStock);

        }

    }

    @Override
    public void  getMaterial(){
        ResponseEntity<List<ErpMaterial>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-bd-org/getMaterial",
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<ErpMaterial>>() {}
        );
        List<ErpMaterial> forObjects = response.getBody();
        System.out.println(forObjects);

        for (ErpMaterial forObject : forObjects) {

            ResponseEntity<List<ErpMaterial>> response2 = restTemplate.exchange(
                    "http://127.0.0.1:9200/erp-bd-org/getMaterialDetail?fnumber="+forObject.getFnumber(),
                    HttpMethod.GET,
                    null,
                    new ParameterizedTypeReference<List<ErpMaterial>>() {}
            );
            //二
            List<ErpMaterial> forObjects2 = response2.getBody();
            System.out.println(forObjects2);


            boolean b = false;
            //判断有没有下级
            for (ErpMaterial erpMaterial : forObjects2) {
                if (erpBdMaterialMapper.exists(new QueryWrapper<ErpBdMaterial>().eq("erp_fnumber", erpMaterial.getFnumber())))
                    continue;
                if(erpMaterial.getFnumber().contains("0000")){

                    ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", erpMaterial.getFacctorgid()));
                    if (ObjectUtil.isEmpty(forgid))
                        continue;
                    if (erpBdMaterialMapper.exists(new QueryWrapper<ErpBdMaterial>().eq("erp_fnumber", erpMaterial.getFnumber()).eq("org_id",forgid.getOrgId()))){
                        continue;
                    }
                    ErpBdMaterial erpBaseMaterial = new ErpBdMaterial();
                    erpBaseMaterial.setErpFnumber(erpMaterial.getFnumber());
                    erpBaseMaterial.setOrgId(forgid.getOrgId());
                    erpBaseMaterial.setFname(erpMaterial.getFname());
                    erpBaseMaterial.setFspecification(erpMaterial.getFspecification());
                    erpBaseMaterial.setUnit("kg");
                    erpBaseMaterial.setConver("1");
                    erpBaseMaterial.setParent(0);
                    erpBdMaterialMapper.insert(erpBaseMaterial);
                    b =true;
                }
            }
            //有下级
            if (b){
                for (ErpMaterial erpMaterial : forObjects2) {
                    if(!erpMaterial.getFnumber().contains("0000")){

                        ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", erpMaterial.getFacctorgid()));
                        if (ObjectUtil.isEmpty(forgid))
                            continue;
                        if (erpBdMaterialMapper.exists(new QueryWrapper<ErpBdMaterial>().eq("erp_fnumber", erpMaterial.getFnumber()).eq("org_id",forgid.getOrgId()))){
                            continue;
                        }
                        ErpBdMaterial erpBaseMaterial = new ErpBdMaterial();
                        erpBaseMaterial.setErpFnumber(erpMaterial.getFnumber());
                        erpBaseMaterial.setOrgId(forgid.getOrgId());
                        erpBaseMaterial.setFname(erpMaterial.getFname());
                        erpBaseMaterial.setFspecification(erpMaterial.getFspecification());
                        erpBaseMaterial.setUnit("kg");
                        erpBaseMaterial.setConver("1");
                        ErpBdMaterial erpBdMaterial = erpBdMaterialMapper.selectOne(new QueryWrapper<ErpBdMaterial>().
                                eq("erp_fnumber", forObject.getFnumber() + "0000").eq("org_id", forgid.getOrgId()));
                        if (ObjectUtil.isEmpty(erpBdMaterial)){
                            continue;
                        }
                        erpBaseMaterial.setParent(erpBdMaterial.getId());
                        erpBdMaterialMapper.insert(erpBaseMaterial);
                    }
                }
            } else {
                for (ErpMaterial erpMaterial : forObjects2) {

                    ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", erpMaterial.getFacctorgid()));
                    if (ObjectUtil.isEmpty(forgid))
                        continue;
                    if (erpBdMaterialMapper.exists(new QueryWrapper<ErpBdMaterial>().eq("erp_fnumber", erpMaterial.getFnumber()).eq("org_id",forgid.getOrgId()))){
                        continue;
                    }
                    ErpBdMaterial erpBaseMaterial = new ErpBdMaterial();
                    erpBaseMaterial.setErpFnumber(erpMaterial.getFnumber());
                    erpBaseMaterial.setOrgId(forgid.getOrgId());
                    erpBaseMaterial.setFname(erpMaterial.getFname());
                    erpBaseMaterial.setFspecification(erpMaterial.getFspecification());
                    erpBaseMaterial.setParent(0);
                    erpBaseMaterial.setUnit("kg");
                    erpBaseMaterial.setConver("1");
                    erpBdMaterialMapper.insert(erpBaseMaterial);

                    ErpBdMaterial erpBaseMaterial1 = new ErpBdMaterial();
                    erpBaseMaterial1.setErpFnumber(erpMaterial.getFnumber());
                    erpBaseMaterial1.setOrgId(forgid.getOrgId());
                    erpBaseMaterial1.setFname(erpMaterial.getFname());
                    erpBaseMaterial1.setFspecification(erpMaterial.getFspecification());
                    erpBaseMaterial1.setParent(erpBaseMaterial.getId());
                    erpBaseMaterial1.setUnit("kg");
                    erpBaseMaterial1.setConver("1");
                    erpBdMaterialMapper.insert(erpBaseMaterial1);
                }
            }
        }
    }

    //获取原材料 等
    @Override
    public void  getMaterialRaw(){
        ResponseEntity<List<ErpMaterial>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-bd-org/getMaterialRaw",
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<ErpMaterial>>() {}
        );
        List<ErpMaterial> forObjects = response.getBody();
        System.out.println(forObjects);
        for (ErpMaterial erpMaterial : forObjects) {
            if (erpBdRawMaterialMapper.exists(new QueryWrapper<ErpBdRawMaterial>().eq("erp_fnumber", erpMaterial.getFnumber())))
                continue;
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", erpMaterial.getFacctorgid()));
            if (ObjectUtil.isEmpty(forgid))
                continue;
            ErpBdRawMaterial erpBdRawMaterial = new ErpBdRawMaterial();
            erpBdRawMaterial.setFspecification(erpMaterial.getFspecification());
            erpBdRawMaterial.setOrgId(forgid.getOrgId());
            erpBdRawMaterial.setErpFnumber(erpMaterial.getFnumber());
            erpBdRawMaterial.setFname(erpMaterial.getFname());
            erpBdRawMaterial.setMaterialType(getType(erpMaterial.getFnumber()));
            erpBdRawMaterial.setMateralId(erpMaterial.getFMATERIALID());
            erpBdRawMaterialMapper.insert(erpBdRawMaterial);
        }
    }

    private Integer getType(String erpFunmber) {
        if (erpFunmber.startsWith("01"))
            return 1;
        else if (erpFunmber.startsWith("10"))
            return 0;
        else if (erpFunmber.startsWith("11"))
            return 3;
        else if (erpFunmber.startsWith("15"))
            return 2;
        else
            return 4;
    }
}
