package vip.xiaonuo.money.param;


import com.fasterxml.jackson.annotation.JsonFormat;
import com.sun.istack.NotNull;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

@Data
public class DsBusAllParam {
    @ApiModelProperty(value = "营业收入", position = 2)
    private String businessIncome;
    @ApiModelProperty(value = "营业收入环比/同比", position = 2)
    private String businessIncomeOnYear;
    @ApiModelProperty(value = "营业收入增加或者减少", position = 2)
    private boolean businessIncomeIsOn;
     @ApiModelProperty(value = "营业收入(本年累计)", position = 2)
    private String businessIncomeYear;
    @ApiModelProperty(value = "营业收入环比/同比(本年累计)", position = 2)
    private String yearBusinessIncomeOnYear;
    @ApiModelProperty(value = "营业收入增加或者减少(本年累计)", position = 2)
    private boolean yearBusinessIncomeIsOn;

    /**
     * 营业成本
     */
    @ApiModelProperty(value = "营业成本", position = 3)
    private String businessCost;
    @ApiModelProperty(value = "营业成本环比/同比", position = 2)
    private boolean businessCostIsOn;
    @ApiModelProperty(value = "营业成本增加或者减少", position = 2)
    private String businessCostOnYear;

    /**
     * 净利润
     */
    @ApiModelProperty(value = "净利润", position = 4)
    private String profit;
    @ApiModelProperty(value = "净利润环比/同比", position = 2)
    private boolean profitIsOn;
    @ApiModelProperty(value = "净利润增加或者减少", position = 2)
    private String profitOnYear;
    @ApiModelProperty(value = "净利润(本年累计)", position = 2)
    private String profitYear;
    @ApiModelProperty(value = "净利润环比/同比(本年累计)", position = 2)
    private boolean yearProfitIsOn;
    @ApiModelProperty(value = "净利润增加或者减少(本年累计)", position = 2)
    private String yearProfitOnYear;

    /**
     * 已交税金
     */
    @ApiModelProperty(value = "已交税金", position = 5)
    private String taxes;
    @ApiModelProperty(value = "已交税金环比/同比", position = 2)
    private boolean taxesIsOn;
    @ApiModelProperty(value = "已交税金增加或者减少", position = 2)
    private String taxesOnYear;
    @ApiModelProperty(value = "已交税金(本年累计)", position = 5)
    private String taxesYear;
    @ApiModelProperty(value = "已交税金环比/同比(本年累计)", position = 2)
    private boolean yearTaxesIsOn;
    @ApiModelProperty(value = "已交税金增加或者减少(本年累计)", position = 2)
    private String yearTaxesOnYear;
    /**
     * 当前资金余额
     */
    @ApiModelProperty(value = "当前资金余额", position = 6)
    private String balance;
    @ApiModelProperty(value = "当前资金余额环比/同比", position = 2)
    private boolean balanceIsOn;
    @ApiModelProperty(value = "当前资金余额增加或者减少", position = 2)
    private String balanceOnYear;
    @ApiModelProperty(value = "当前资金余额(本年累计)", position = 6)
    private String balanceYear;

    @ApiModelProperty(value = "银行借款金额", position = 6)
    private String borrowPrice;
    @ApiModelProperty(value = "银行还款金额", position = 6)
    private String repaymentPrice;
    @ApiModelProperty(value = "银行借款金额环比/同比", position = 2)
    private boolean borrowPriceIsOn;
    @ApiModelProperty(value = "银行借款金额增加或者减少", position = 2)
    private String borrowPriceOnYear;
    @ApiModelProperty(value = "银行借款金额(本年累计)", position = 6)
    private String borrowPriceYear;

    @ApiModelProperty(value = "应收金额", position = 6)
    private String invoiceMoney;
//    @JsonFormat(pattern = "yyyy-MM",timezone = "GMT+8")
//    private Date mmonth;

    private String ymonth;


}
