package vip.xiaonuo.purchase.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.io.Serializable;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import javax.naming.Name;

/**
 * <p>
 * 采购应付账款
 * </p>
 *
 * @author author
 * @since 2024-11-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("purchase_pay")
public class PurchasePay implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 应付对象
     */
    @ApiModelProperty(value = "应付对象", position = 2)
    private String payableObject;

    /**
     * 采购物资
     */
    @ApiModelProperty(value = "采购物资", position = 3)
    private String purchaseMaterial;

    /**
     * 采购数量
     */
    @ApiModelProperty(value = "采购数量", position = 4)
    private String purchaseNumber;

    /**
     * 单价
     */
    @ApiModelProperty(value = "单价", position = 5)
    private String price;

    /**
     * 应付账款
     */
    @ApiModelProperty(value = "应付账款", position = 6)
    private String payableNumber;

    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间", position = 7)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date createTime;

    /**
     * 截至时间
     */
    @ApiModelProperty(value = "截至时间", position = 8)
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date endTime;

    /**
     * 组织id
     */
    @ApiModelProperty(value = "组织id", position = 2)
    private String orgId;


    //应收单号
    @TableField("billno")
    private String FBILLNO;
    //采购组织
    @TableField("FPURCHASEORGID")
    private int FPURCHASEORGID;
    //付款组织
    @TableField("FPAYORGID")
    private int FPAYORGID;
    //客户id
    @TableField("FSUPPLIERID")
    private int FSUPPLIERID;
    // 源单号
    @TableField("FSourceBillNo")
    private String FSourceBillNo;
    //采购合同号
    @TableField("FBGLCONTRACTL")
    private String FBGLCONTRACTL;
    //物料编码
    @TableField("FMATERIALID")
    private String FMATERIALID;
    //含税单价
    @TableField("FTaxPrice")
    private String FTaxPrice;
    //采购订单详细号
    @TableField("FOrderEntryID")
    private int FOrderEntryID;
    //规格
    @TableField("FSPECIFICATION")
    private String FSPECIFICATION;



}
