package vip.xiaonuo.purchase.mapper;

import cn.hutool.core.date.DateTime;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import org.apache.ibatis.annotations.Param;
import vip.xiaonuo.money.param.DsBusAllParam;
import vip.xiaonuo.purchase.entity.PurchaseOrder;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import vip.xiaonuo.purchase.entity.vo.PurchaseMaterialVo;
import vip.xiaonuo.purchase.entity.vo.PurchaseOrderTypeVo;
import vip.xiaonuo.purchase.entity.vo.PurchaseOrderVo;
import vip.xiaonuo.purchase.param.PurchaseAllParam;

import java.util.List;

/**
 * <p>
 * 采购订单表 Mapper 接口
 * </p>
 *
 * @author author
 * @since 2024-11-25
 */
public interface PurchaseOrderMapper extends BaseMapper<PurchaseOrder> {

    PurchaseOrderTypeVo listType(DateTime beginOfMonth,
                                 DateTime   endOfMonth,
                                 DateTime  beginOfYear,
                                 DateTime  endOfYear,
                                 DateTime  lastbeginOfMonth,
                                 DateTime  lastendOfMonth,
                                 DateTime   lastbeginOfYear,
                                 DateTime   lastendOfYear,
                                 String orgId, @Param(value = "materalId")Integer materalId);

    List<PurchaseMaterialVo> getSupplier(@Param(Constants.WRAPPER) QueryWrapper<PurchaseOrder> queryWrapper);

    PurchaseAllParam purchaseAll(@Param(Constants.WRAPPER)  QueryWrapper<PurchaseOrder> wapper);

    List<PurchaseAllParam> getCaiGouYvFuDetailMonth(@Param(Constants.WRAPPER)QueryWrapper<PurchaseOrder> wapper);

    List<PurchaseAllParam> getCaiGouYvFuDetailYear(@Param(Constants.WRAPPER) QueryWrapper<PurchaseOrder> wapper);

    PurchaseOrderVo getOrder( @Param(Constants.WRAPPER) QueryWrapper<PurchaseOrder> queryWrapper);

    List<PurchaseAllParam> getKunChunJinE(@Param(Constants.WRAPPER)QueryWrapper<PurchaseOrder> wapper);

    List<PurchaseAllParam> getKunChunJinEYear(@Param(Constants.WRAPPER)QueryWrapper<PurchaseOrder> wapper);

    List<PurchaseAllParam> getZhuYaoYuanCaiNumDetil(@Param(Constants.WRAPPER)QueryWrapper<PurchaseOrder> wapper);

    List<PurchaseAllParam> getZhuYaoYuanCaiNumDetilYear(@Param(Constants.WRAPPER)QueryWrapper<PurchaseOrder> wapper);
}
