package vip.xiaonuo.risk.service.impl;

import cn.hutool.core.date.DateField;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import vip.xiaonuo.risk.entity.RiskContract;
import vip.xiaonuo.risk.entity.RiskSale;
import vip.xiaonuo.risk.entity.RiskSaleVo;
import vip.xiaonuo.risk.mapper.RiskContractMapper;
import vip.xiaonuo.risk.mapper.RiskSaleMapper;
import vip.xiaonuo.risk.param.RiskSaleParam;
import vip.xiaonuo.risk.service.IRiskSaleService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import vip.xiaonuo.sale.entity.SaleDetail;
import vip.xiaonuo.sale.mapper.SaleDetailMapper;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 风控销售回款 服务实现类
 * </p>
 *
 * @author author
 * @since 2024-12-09
 */
@Service
public class RiskSaleServiceImpl extends ServiceImpl<RiskSaleMapper, RiskSale> implements IRiskSaleService {

    @Autowired
    private RiskSaleMapper saleMapper;
    @Autowired
    private SaleDetailMapper saleDetailMapper;

    @Autowired
    private RiskContractMapper riskContractMapper;

    @Override
    public List<RiskSaleVo> getList(RiskSaleParam riskSaleParam) {
        String orgId = riskSaleParam.getOrgId();
        Integer timeType = riskSaleParam.getTimeType();
        Integer number = riskSaleParam.getNumber();
        QueryWrapper<RiskContract> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(StringUtils.isNotBlank(orgId), "org_id", orgId);
        List<RiskSaleVo> list ;
        if (1 == timeType) {
            if (null == number) {
                number = 13;
            }
            queryWrapper.between("create_time", DateUtil.offsetMonth(DateUtil.beginOfMonth(new Date()),-number),new Date());
            list = riskContractMapper.getListMonth(queryWrapper);
        } else {

            if (null == number) {
                number = 3;
            }
            queryWrapper.between("create_time", DateUtil.offset(DateUtil.beginOfYear(new Date()), DateField.YEAR,-number),new Date());
            list = riskContractMapper.getListMonthYear(queryWrapper);
        }

        return list;
    }
}
