/*
 * Copyright [2022] [https://www.baiduc.com]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.baiduc.com
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.baiduc.com
 */
package vip.xiaonuo;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.junit.Test;
import org.junit.platform.commons.function.Try;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.core.ParameterizedTypeReference;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.web.client.RestTemplate;
import vip.xiaonuo.erp.entity.*;
import vip.xiaonuo.erp.entity.voucher.ErpMaterial;
import vip.xiaonuo.erp.mapper.*;
import vip.xiaonuo.erp.service.IErpZhiLiangService;
import vip.xiaonuo.production.entity.ProduceLocation;
import vip.xiaonuo.production.mapper.ProduceLocationMapper;
import vip.xiaonuo.quality.entity.ErpBdQuail;
import vip.xiaonuo.quality.entity.QualityFenxibaogao;
import vip.xiaonuo.quality.entity.QualityReagentStock;
import vip.xiaonuo.quality.entity.vo.ErpQualiQm;
import vip.xiaonuo.quality.mapper.ErpBdQuailMapper;
import vip.xiaonuo.quality.mapper.QualityFenxibaogaoMapper;
import vip.xiaonuo.quality.mapper.QualityReagentStockMapper;
import vip.xiaonuo.quality.service.IQualityReagentService;
import vip.xiaonuo.quality.service.IQualityReagentStockService;

import java.util.Date;
import java.util.List;

/**
 * 主测试类
 *
 * @author xuyuxiang
 * @date 2022/9/17 17:09
 */
@RunWith(SpringRunner.class)
@SpringBootTest(classes = Application.class)
public class Bdest {

    @Autowired
    private IErpZhiLiangService erpZhiLiangService;
    @Autowired
    private  QualityFenxibaogaoMapper qualityFenxibaogaoMapper;

    @Test
    public void  test(){
        List<QualityFenxibaogao> qualityFenxibaogaos = qualityFenxibaogaoMapper.selectList(null);
        for (QualityFenxibaogao qualityFenxibaogao : qualityFenxibaogaos) {
            String specificOtation = qualityFenxibaogao.getSpecificOtation();
            try {
                double v = Double.parseDouble(specificOtation);
                qualityFenxibaogao.setSpecificOtation(String.format("%.4f",v));
                System.out.println(" ------");
                qualityFenxibaogaoMapper.updateById(qualityFenxibaogao);
            }catch (Exception e){
                System.out.println(e +" 转换错误");
            }

        }
    }
    //物料分组
    @Test
    public void  test8() {
        erpZhiLiangService.getMaterialGruop();
    }


    //获取质量 所有记录
    @Test
    public void  test6(){
        DateTime dateTime = DateUtil.beginOfDay(new Date());
        erpZhiLiangService.getQuailIbit(dateTime);
    }

    //获取车间
    @Test
    public void  test2(){
        erpZhiLiangService.getCheJian();
    }
    //获取质量检验项目
    @Test
    public void  test5(){
        erpZhiLiangService.getQuail();
    }

    //获取试剂
    @Test
    public void  test4(){
        erpZhiLiangService.getReagent();
    }

    @Test
    public void  test1(){
        erpZhiLiangService.getMaterial();
    }

    //获取原材料 等
    @Test
    public void  test7(){
        erpZhiLiangService.getMaterialRaw();
    }
}
