/*
 * Copyright [2022] [https://www.baiduc.com]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.baiduc.com
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.baiduc.com
 */
package vip.xiaonuo;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUnit;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.junit.Test;
import org.junit.platform.commons.util.StringUtils;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.core.ParameterizedTypeReference;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.client.RestTemplate;
import vip.xiaonuo.erp.entity.ErpBdDepartment;
import vip.xiaonuo.erp.entity.ErpBdMaterial;
import vip.xiaonuo.erp.entity.ErpBdOrg;
import vip.xiaonuo.erp.entity.ErpBdRawMaterial;
import vip.xiaonuo.erp.entity.fengkong.FengKongKuanDao;
import vip.xiaonuo.erp.entity.voucher.ErpMaterial;
import vip.xiaonuo.erp.mapper.ErpBdDepartmentMapper;
import vip.xiaonuo.erp.mapper.ErpBdMaterialMapper;
import vip.xiaonuo.erp.mapper.ErpBdOrgMapper;
import vip.xiaonuo.erp.mapper.ErpBdRawMaterialMapper;
import vip.xiaonuo.erp.service.IErpFengKongService;
import vip.xiaonuo.production.entity.ProduceLocation;
import vip.xiaonuo.production.mapper.ProduceLocationMapper;
import vip.xiaonuo.quality.entity.ErpBdQuail;
import vip.xiaonuo.quality.entity.QualityFenxibaogao;
import vip.xiaonuo.quality.entity.QualityReagentStock;
import vip.xiaonuo.quality.entity.vo.ErpQualiQm;
import vip.xiaonuo.quality.mapper.ErpBdQuailMapper;
import vip.xiaonuo.quality.mapper.QualityFenxibaogaoMapper;
import vip.xiaonuo.quality.mapper.QualityReagentStockMapper;
import vip.xiaonuo.risk.entity.RiskContract;
import vip.xiaonuo.risk.entity.RiskContractWarning;
import vip.xiaonuo.risk.mapper.RiskContractMapper;
import vip.xiaonuo.risk.mapper.RiskContractWarningMapper;
import vip.xiaonuo.sale.entity.SaleReceive;
import vip.xiaonuo.sale.mapper.SaleReceiveMapper;

import java.util.Date;
import java.util.List;

/**
 * 主测试类
 *
 * @author xuyuxiang
 * @date 2022/9/17 17:09
 */
@RunWith(SpringRunner.class)
@SpringBootTest(classes = Application.class)
public class FengKongTest {


    @Autowired
    private IErpFengKongService erpFengKongService;


    //风控款到发货
    @Test
    public void  test1(){
        DateTime parse = DateUtil.parse("2024-10-30", "yyyy-MM-dd");
        // 10-29
        erpFengKongService.getKuanDaoFaHuo(parse);

    }


    //风控逾期合同
    @Test
    public void  test2(){
        DateTime parse = DateUtil.parse("2024-10-30", "yyyy-MM-dd");
        // 10-29
        erpFengKongService.getCaiGouYvQi(parse);

    }

}
