/*
 * Copyright [2022] [https://www.baiduc.com]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.baiduc.com
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.baiduc.com
 */
package vip.xiaonuo;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson2.schema.ValidateResult;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.junit.Test;
import org.junit.platform.commons.util.StringUtils;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.core.ParameterizedTypeReference;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.client.RestTemplate;
import vip.xiaonuo.erp.entity.ErpBdOrg;
import vip.xiaonuo.erp.entity.caigou.*;
import vip.xiaonuo.erp.mapper.ErpBdOrgMapper;
import vip.xiaonuo.erp.service.IErpCaiGouService;
import vip.xiaonuo.purchase.entity.PurchaseContract;
import vip.xiaonuo.purchase.entity.PurchaseOrder;
import vip.xiaonuo.purchase.entity.PurchasePay;
import vip.xiaonuo.purchase.entity.PurchasePrice;
import vip.xiaonuo.purchase.mapper.PurchaseContractMapper;
import vip.xiaonuo.purchase.mapper.PurchaseOrderMapper;
import vip.xiaonuo.purchase.mapper.PurchasePayMapper;
import vip.xiaonuo.purchase.mapper.PurchasePriceMapper;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

/**
 * 主测试类
 *
 * @author xuyuxiang
 * @date 2022/9/17 17:09
 */
@RunWith(SpringRunner.class)
@SpringBootTest(classes = Application.class)
public class MainTest {

    @Autowired
    private RestTemplate restTemplate;

    @Autowired
    private ErpBdOrgMapper erpBdOrgMapper;

    @Autowired
    private IErpCaiGouService erpCaiGouService;

    @Test
    public void test() {
        Date parse = DateUtil.parse("2000-10-30", "yyyy-MM-dd");
        erpCaiGouService.getCaiGouDingDanShuLiangJinE(parse);

    }

    @Test
    public void  test2(){
        Date parse = DateUtil.parse("2000-10-30", "yyyy-MM-dd");
        erpCaiGouService.getCaiGouRuku(parse);

    }

    @Test
    public void  test3(){
        Date parse = DateUtil.parse("2000-10-30", "yyyy-MM-dd");
        erpCaiGouService.getCaiGouFaPiao(parse);
    }

    @Test
    public void  test4(){
        //不用了
        Date parse = DateUtil.parse("2024-10-30", "yyyy-MM-dd");
        erpCaiGouService.getLeiJiRuKu(parse);
    }
    //-- 1
    @Test
    public void  test5(){
        Date parse = DateUtil.parse("2000-10-30", "yyyy-MM-dd");
        erpCaiGouService.getShouLiaoJinE(parse);
    }

    @Test
    public void  test6(){

        Date parse = DateUtil.parse("2000-10-30", "yyyy-MM-dd");
        erpCaiGouService.getJiaoHuoShuLiang(parse);
    }


    @Test
    public void  test7(){
        //不用
        Date parse = DateUtil.parse("2024-10-30", "yyyy-MM-dd");
        erpCaiGouService.getCaiGouShuLiang(parse);
    }

    //重新写了 TODO
    @Test
    public void  test8(){
        Date parse = DateUtil.parse("2024-10-30", "yyyy-MM-dd");
        erpCaiGouService.getYingFuZhangKuang(parse);
    }
    @Test
    public void  test9(){
        Date parse = DateUtil.parse("2024-10-30", "yyyy-MM-dd");
        erpCaiGouService.getCaiGouHeTongShuLiangJinE(parse);

    }
    @Test
    public void  test10() {
        ResponseEntity<List<ZuiDiKuChun>> response = restTemplate.exchange(
                "http://127.0.0.1:9200/erp-caiGou/getZuiDiKuChun?date=",
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<List<ZuiDiKuChun>>() {}
        );
        List<ZuiDiKuChun> forObjects = response.getBody();
        System.out.println(forObjects);
        for (ZuiDiKuChun forObject : forObjects) {
            ErpBdOrg forgid = erpBdOrgMapper.selectOne(new QueryWrapper<ErpBdOrg>().eq("forgid", forObject.getFSTOCKORGID()));
            if (ObjectUtil.isEmpty(forgid))
                continue;

        }

    }

}
