/*
 * Copyright [2022] [https://www.baiduc.com]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.baiduc.com
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.baiduc.com
 */
package vip.xiaonuo;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.junit.Test;
import org.junit.platform.commons.util.StringUtils;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.core.ParameterizedTypeReference;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.web.client.RestTemplate;
import vip.xiaonuo.erp.entity.ErpBdOrg;
import vip.xiaonuo.erp.entity.caigou.CaiGouRuKu;
import vip.xiaonuo.erp.entity.kucun.ChenPinChuKu;
import vip.xiaonuo.erp.entity.kucun.WuLiaoKuMingXi;
import vip.xiaonuo.erp.entity.kucun.YuanCaiLiaoKuCun;
import vip.xiaonuo.erp.entity.xiaoshou.*;
import vip.xiaonuo.erp.mapper.ErpBdOrgMapper;
import vip.xiaonuo.erp.service.IErpXiaoShouService;
import vip.xiaonuo.money.entity.MoneyCost;
import vip.xiaonuo.money.entity.MoneyOverdue;
import vip.xiaonuo.money.entity.MoneyProduce;
import vip.xiaonuo.money.entity.MoneyWriteOverdue;
import vip.xiaonuo.money.mapper.MoneyCostMapper;
import vip.xiaonuo.money.mapper.MoneyOverdueMapper;
import vip.xiaonuo.money.mapper.MoneyProduceMapper;
import vip.xiaonuo.money.mapper.MoneyWriteOverdueMapper;
import vip.xiaonuo.sale.entity.*;
import vip.xiaonuo.sale.mapper.*;
import vip.xiaonuo.warehouse.entity.*;
import vip.xiaonuo.warehouse.mapper.*;

import java.util.Date;
import java.util.List;

/**
 * 主测试类
 *
 * @author xuyuxiang
 * @date 2022/9/17 17:09
 */
@RunWith(SpringRunner.class)
@SpringBootTest(classes = Application.class)
public class XiaoShouTest {

    @Autowired
    private IErpXiaoShouService erpXiaoShouService;


    @Test
    public void test1() {
        Date parse = DateUtil.parse("2024-10-30", "yyyy-MM-dd");
        erpXiaoShouService.getWanChengLv(parse);
    }

    //订单金额
    @Test
    public void test8() {
        Date parse = DateUtil.parse("2024-10-30", "yyyy-MM-dd");
        erpXiaoShouService.getDingDan(parse);

    }
    @Test
    public void test2() {
        Date parse = DateUtil.parse("2024-10-29", "yyyy-MM-dd");
        erpXiaoShouService.getXiaoShouFeiYong2(parse);
    }

    @Test
    public void test2_1() {
        Date parse = DateUtil.parse("2024-10-01", "yyyy-MM-dd");
        erpXiaoShouService.getXiaoShouFeiYong21(parse);

    }

    @Test
    public void test2_2() {
        Date parse = DateUtil.parse("2024-10-01", "yyyy-MM-dd");
        erpXiaoShouService.getXiaoShouFeiYong22(parse);


    }

    @Test
    public void test2_3() {
        Date parse = DateUtil.parse("2024-10-01", "yyyy-MM-dd");
        erpXiaoShouService.getXiaoShouFeiYong23(parse);
    }

    @Test
    public void test2_4() {
        Date parse = DateUtil.parse("2024-10-01", "yyyy-MM-dd");
        erpXiaoShouService.getXiaoShouFeiYong24(parse);
    }

    @Test
    public void test3() {
        Date parse = DateUtil.parse("2024-10-30", "yyyy-MM-dd");
        erpXiaoShouService.getXiaoShouFaHuoJinEKeHuGongXian(parse);

    }

    @Test
    public void test4() {
        Date parse = DateUtil.parse("2024-10-30", "yyyy-MM-dd");
        erpXiaoShouService.getXiaoShouFaPiaoJinE(parse);
    }

    @Test
    public void test5() {
        //不用
        Date parse = DateUtil.parse("2024-10-30", "yyyy-MM-dd");
        erpXiaoShouService.getYvQiHeTongMingXi(parse);
    }
    //== 改过的
    @Test
    public void testCaiWuYingShou() {
        Date parse = DateUtil.parse("2024-10-30", "yyyy-MM-dd");
        erpXiaoShouService.getCaiWuYingShou("202410");
    }


    @Test
    public void  test6() {
        Date parse = DateUtil.parse("2024-10-30", "yyyy-MM-dd");
//        erpXiaoShouService.getBaiFangKeHu(parse)
    }

    private String getNum(BaiFangKeHu forObject) {
        if (StringUtils.isBlank(forObject.getFZCREMARKS2())){
            return "1";
        }else if (StringUtils.isBlank(forObject.getFZCREMARKS3())){
            return "2";
        } else if (StringUtils.isBlank(forObject.getFZCREMARKS4())){
            return "3";
        }else if (StringUtils.isNotBlank(forObject.getFZCREMARKS4())){
            return "4";
        }else {
            return "1";
        }
    }


}
